require "defines"




game.oninit(function()

	game.player.force.disableallprototypes()
  	game.player.force.disableresearch()

	glob.snake = {}
		glob.snake.tick = 0
		glob.snake.direction = 1 	
		glob.snake.playground = {}
			glob.snake.playground.topleft = {x = -7, y = -7}
			glob.snake.playground.bottomright = {x = 8, y = 7}
		glob.snake.segments = {}
			glob.snake.segments.pos = {}
				glob.snake.segments.pos[1] = {x = -3, y = -2}
				glob.snake.segments.pos[2] = {x = -2, y = -2}
				glob.snake.segments.pos[3] = {x = -1, y = -2}
				glob.snake.segments.pos[4] = {x = 0, y = -2}
		glob.snake.score = 0
		glob.snake.speed = 55
		glob.snake.started = false
		glob.snake.ate = false

	game.player.gui.top.add{type="button", name="restart_button", caption= "Start"}
	game.player.gui.top.add{type="button", name="slower_button", caption= "slower"}
	game.player.gui.top.add{type="button", name="faster_button", caption= "faster"}
	game.player.gui.top.add{type="button", name="score_label", caption= "Score: " ..glob.snake.score}

end)


game.onevent(defines.events.ontick, function(event)

	if glob.snake.started == true then
		glob.snake.tick = glob.snake.tick + 1

		if ((glob.snake.tick % glob.snake.speed) == 0) then

			if (game.player.character.position.x < 11) then
				glob.snake.direction = 1 -- Left
			elseif (game.player.character.position.y < 3) then
				glob.snake.direction = 2	-- Up
			elseif (game.player.character.position.x > 13) then
				glob.snake.direction = 3 -- Right
			elseif (game.player.character.position.y > 5) then
				glob.snake.direction = 4	-- Down
			end

			local coal = game.findentitiesfiltered{area ={glob.snake.playground.topleft , glob.snake.playground.bottomright}, name ="coal"}

			for i = 1, #coal do
				if coal[i].name =="coal" then
					if (math.abs((coal[1].position.x - 0.5) - glob.snake.segments.pos[1].x) < 0.5)  and (math.abs((coal[1].position.y-0.5) - glob.snake.segments.pos[1].y) < 0.7) then
						game.player.print("Yummi")
						local speed = 10 - 0.2 * (glob.snake.speed - 10)
						glob.snake.score = glob.snake.score + speed
						game.player.gui.top.score_label.caption = "Score: " ..glob.snake.score
						coal[1].destroy()
						glob.snake.ate = true
						local rnd_x = math.floor(math.random()*15)
						local rnd_y = math.floor(math.random()*14)
						game.createentity{name ="coal", position = {glob.snake.playground.topleft.x + rnd_x, glob.snake.playground.topleft.y + rnd_y}}
					end
				end
			end

			draw_update(glob.snake.direction)

			if (glob.snake.segments.pos[1].x < -7)  or (glob.snake.segments.pos[1].x > 7) or (glob.snake.segments.pos[1].y < -7) or (glob.snake.segments.pos[1].y > 6) then	
				game_over()
				restart()
			end

			for k, segments in ipairs(glob.snake.segments.pos) do
				if k > 1 then
					if (glob.snake.segments.pos[1].x == segments.x) and (glob.snake.segments.pos[1].y == segments.y) then
						game_over()
						restart()
					end
				end
			end
		end
	end
end)


game.onevent(defines.events.onguiclick, function(event)

	if event.element.name == "restart_button" then
		if game.player.gui.top.restart_button.caption == "Start" then
			game.player.gui.top.restart_button.caption = "Restart"
			glob.snake.started = true
		end
		game.setdaytime(0.0)
		game.freezedaytime(true)
		restart()
	end

	if event.element.name == "slower_button" then
		if glob.snake.speed < 55 then
			glob.snake.speed = glob.snake.speed + 5
		end
		local speed = 10 - 0.2 * (glob.snake.speed - 10)
		game.player.print("Speed: " ..speed)
	end

	if event.element.name == "faster_button" then
		if glob.snake.speed > 10 then
			glob.snake.speed = glob.snake.speed - 5
		end
		local speed = 10 - 0.2 * (glob.snake.speed - 10)
		game.player.print("Speed: " ..speed)
	end

end)


function draw_update(direction)
	
	local entities = game.findentities{ glob.snake.playground.topleft , glob.snake.playground.bottomright}
	
	for _, entity in ipairs(entities) do 
		if entity.name == "pipe" then
			entity.destroy()
		end
	end

	if glob.snake.ate == false then	
		for i = #glob.snake.segments.pos, 2, -1 do
			glob.snake.segments.pos[i].x = glob.snake.segments.pos[i - 1].x
			glob.snake.segments.pos[i].y = glob.snake.segments.pos[i - 1].y
		end
	
		if direction == 1 then
			glob.snake.segments.pos[1].x = glob.snake.segments.pos[1].x - 1
		elseif direction == 2 then
			glob.snake.segments.pos[1].y = glob.snake.segments.pos[1].y - 1
		elseif direction == 3 then
			glob.snake.segments.pos[1].x = glob.snake.segments.pos[1].x + 1
		elseif direction == 4 then
			glob.snake.segments.pos[1].y = glob.snake.segments.pos[1].y + 1
		end
		
		for i = 1, #glob.snake.segments.pos, 1 do
			game.createentity{name = "pipe", position = glob.snake.segments.pos[i]}
		end	
	else
		glob.snake.segments.pos[#glob.snake.segments.pos + 1] = {}
			for i = #glob.snake.segments.pos, 2, -1 do
				glob.snake.segments.pos[i].x = glob.snake.segments.pos[i - 1].x
				glob.snake.segments.pos[i].y = glob.snake.segments.pos[i - 1].y
			end
		if direction == 1 then
			glob.snake.segments.pos[1].x = glob.snake.segments.pos[1].x - 1
		elseif direction == 2 then
			glob.snake.segments.pos[1].y = glob.snake.segments.pos[1].y - 1
		elseif direction == 3 then
			glob.snake.segments.pos[1].x = glob.snake.segments.pos[1].x + 1
		elseif direction == 4 then
			glob.snake.segments.pos[1].y = glob.snake.segments.pos[1].y + 1
		end
		
		for i = 1, #glob.snake.segments.pos, 1 do
			game.createentity{name = "pipe", position = glob.snake.segments.pos[i]}
		end
		glob.snake.ate = false
	end
end


function game_over()
	game.showmessagedialog("You lost! Your final score: " ..glob.snake.score)
	glob.snake.started = false
	game.player.gui.top.restart_button.caption = "Start"
end

function restart()

	glob.snake.score = 0
	game.player.gui.top.score_label.caption = "Score: " ..glob.snake.score
	local entities = game.findentities{ glob.snake.playground.topleft , glob.snake.playground.bottomright}
	
	for _, entity in ipairs(entities) do 
		entity.destroy()
	end
	
	while (glob.snake.segments.pos[1]~= nil) do
		table.remove(glob.snake.segments.pos)
	end
	
	glob.snake.direction = 1 
	glob.snake.segments.pos = {}
		glob.snake.segments.pos[1] = {x = -3, y = -2}
		glob.snake.segments.pos[2] = {x = -2, y = -2}
		glob.snake.segments.pos[3] = {x = -1, y = -2}
		glob.snake.segments.pos[4] = {x = 0, y = -2}
	local rnd_x = math.floor(math.random()*15)
	local rnd_y = math.floor(math.random()*14)
	game.createentity{name ="coal", position = {glob.snake.playground.topleft.x + rnd_x, glob.snake.playground.topleft.y + rnd_y}}
end